﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO.Ports;
using System.IO;
using System.Threading;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        bool isConnected = false;
        SerialPort port;
        int ArrSaveCount = 400; //Можно сохранять 100 действий 
        public Form1()
        {
            InitializeComponent();
        }



        private void button1_Click(object sender, EventArgs e)
        {
            comboBox1.Items.Clear();
            // Получаем список COM портов доступных в системе
            string[] portnames = SerialPort.GetPortNames();
            // Проверяем есть ли доступные
            if (portnames.Length == 0)
            {
                MessageBox.Show("COM PORT not found");
            }
            foreach (string s in portnames)
            {
                //добавляем доступные COM порты в список              
                comboBox1.Items.Add(s);
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (!isConnected)
            {
                connectToArduino();
            }
            else
            {
                disconnectFromArduino();
            }
        }

        private void connectToArduino()
        {
            isConnected = true;
            string selectedPort = comboBox1.GetItemText(comboBox1.SelectedItem);
            port = new SerialPort(selectedPort, 9600, Parity.None, 8, StopBits.One);
            port.Open();
            button2.Text = "Disconnect";
        }

        private void disconnectFromArduino()
        {
            isConnected = false;
            port.Close();
            button2.Text = "Connect";
        }

        private void button3_Click(object sender, EventArgs e)
        {
            port.Write("#x|");
        }

        private void button4_Click(object sender, EventArgs e)
        {
            port.Write("#w|");
        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            String UgolServo = "#A";
            UgolServo = UgolServo + Convert.ToString(trackBar1.Value, 16);
            UgolServo = UgolServo + "|";
            port.Write(UgolServo);
            tb0.Text = Convert.ToString(trackBar1.Value);
        }

        private void trackBar2_Scroll(object sender, EventArgs e)
        {
            String UgolServo = "#B";
            UgolServo = UgolServo + Convert.ToString(trackBar2.Value, 16);
            UgolServo = UgolServo + "|";
            port.Write(UgolServo);
            tb4.Text = Convert.ToString(trackBar2.Value);
        }

        private void Form1_Shown(object sender, EventArgs e)
        {
            
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //Загрузка формы

            
            //если файл настроек существует переписываем значения в окошки формы!!!
            if (File.Exists("DefaultValues.dat")) {
            //MessageBox.Show("Файл есть загружаем", "Отладочое окошко");
            //Загружаем настройки !!!        
            using (FileStream input = File.OpenRead("DefaultValues.dat"))
            using (BinaryReader reader = new BinaryReader(input))
            {
            byte[] LoadArray = reader.ReadBytes(16);
            tb0.Text = Convert.ToString(LoadArray[0]);
            tb1.Text = Convert.ToString(LoadArray[1]);
            tb2.Text = Convert.ToString(LoadArray[2]);
            tb3.Text = Convert.ToString(LoadArray[3]);
            tb4.Text = Convert.ToString(LoadArray[4]);
            tb5.Text = Convert.ToString(LoadArray[5]);
            tb6.Text = Convert.ToString(LoadArray[6]);
            tb7.Text = Convert.ToString(LoadArray[7]);
            tb8.Text = Convert.ToString(LoadArray[8]);
            tb9.Text = Convert.ToString(LoadArray[9]);
            tb10.Text = Convert.ToString(LoadArray[10]);
            tb11.Text = Convert.ToString(LoadArray[11]);
            tb12.Text = Convert.ToString(LoadArray[12]);
            tb13.Text = Convert.ToString(LoadArray[13]);
            tb14.Text = Convert.ToString(LoadArray[14]);
            tb15.Text = Convert.ToString(LoadArray[15]);
            //ставим ползунки
            trackBar1.Value = int.Parse(tb1.Text);
            trackBar2.Value = int.Parse(tb5.Text);
            trackBar3.Value = int.Parse(tb9.Text);
            trackBar4.Value = int.Parse(tb13.Text);
            //применяем ограничения
            trackBar1.Minimum = Convert.ToByte(tb2.Text);
            trackBar1.Maximum = Convert.ToByte(tb3.Text);
            trackBar2.Minimum = Convert.ToByte(tb6.Text);
            trackBar2.Maximum = Convert.ToByte(tb7.Text);
            trackBar3.Minimum = Convert.ToByte(tb10.Text);
            trackBar3.Maximum = Convert.ToByte(tb11.Text);
            trackBar4.Minimum = Convert.ToByte(tb14.Text);
            trackBar4.Maximum = Convert.ToByte(tb15.Text);
            }
            }

        }


        private void BT_SaveSittings_Click(object sender, EventArgs e)
        {
            //Сохраняем настройки !!!        
            using (FileStream output = File.Create("DefaultValues.dat"))
            using (BinaryWriter writer = new BinaryWriter(output))
            {
                byte[] SaveArray = new byte[16];
                SaveArray[0] = Convert.ToByte(tb1.Text);
                SaveArray[1] = Convert.ToByte(tb1.Text);
                SaveArray[2] = Convert.ToByte(tb2.Text);
                SaveArray[3] = Convert.ToByte(tb3.Text);
                SaveArray[4] = Convert.ToByte(tb5.Text);
                SaveArray[5] = Convert.ToByte(tb5.Text);
                SaveArray[6] = Convert.ToByte(tb6.Text);
                SaveArray[7] = Convert.ToByte(tb7.Text);
                SaveArray[8] = Convert.ToByte(tb9.Text);
                SaveArray[9] = Convert.ToByte(tb9.Text);
                SaveArray[10] = Convert.ToByte(tb10.Text);
                SaveArray[11] = Convert.ToByte(tb11.Text);
                SaveArray[12] = Convert.ToByte(tb13.Text);
                SaveArray[13] = Convert.ToByte(tb13.Text);
                SaveArray[14] = Convert.ToByte(tb14.Text);
                SaveArray[15] = Convert.ToByte(tb15.Text);
                writer.Write(SaveArray);
                trackBar1.Minimum = Convert.ToByte(tb2.Text);
                trackBar1.Maximum = Convert.ToByte(tb3.Text);
                trackBar2.Minimum = Convert.ToByte(tb6.Text);
                trackBar2.Maximum = Convert.ToByte(tb7.Text);
                trackBar3.Minimum = Convert.ToByte(tb10.Text);
                trackBar3.Maximum = Convert.ToByte(tb11.Text);
                trackBar4.Minimum = Convert.ToByte(tb14.Text);             
                trackBar4.Maximum = Convert.ToByte(tb15.Text);
            }
        }

        private void trackBar4_Scroll(object sender, EventArgs e)
        {

            String UgolServo = "#D";
            UgolServo = UgolServo + Convert.ToString(trackBar4.Value, 16);
            UgolServo = UgolServo + "|";
            port.Write(UgolServo);                  
            tb12.Text = Convert.ToString(trackBar4.Value);
        }

        private void trackBar3_Scroll(object sender, EventArgs e)
        {
            String UgolServo = "#C";
            UgolServo = UgolServo + Convert.ToString(trackBar3.Value, 16);
            UgolServo = UgolServo + "|";
            port.Write(UgolServo);
            tb8.Text = Convert.ToString(trackBar3.Value);
        }

        private void button5_Click(object sender, EventArgs e)
        {
        dataGridView1.Rows.Add(tb0.Text, tb4.Text, tb8.Text, tb12.Text);
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //открываем файл актионс если он есть
            if (!File.Exists("Actions.dat")) {
            MessageBox.Show("Файл Actions.dat не существует", "Ошибка загрузки");
            } else {
            //загружаем данные из файла в табличку
            
            using (FileStream input = File.OpenRead("Actions.dat"))
            using (BinaryReader reader = new BinaryReader(input))
            {
            byte[] ArrLoad = reader.ReadBytes(ArrSaveCount);
            //Ищем в массиве заглушку
            byte b = 255;
            int index = Array.LastIndexOf(ArrLoad, b);

            int i = 0;
            while (i < index) 
            {
            dataGridView1.Rows.Add(ArrLoad[i], ArrLoad[i + 1], ArrLoad[i + 2], ArrLoad[i + 3]);
            i = i + 4;
            }
            

            //MessageBox.Show(Convert.ToString(index));

            } 
            }


        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Int16 i, j, a;
            a = 0;
            Byte[] ArrSave = new Byte[ArrSaveCount];            //Массив для сохранения таблички (максимум 100 строк)

            for (i = 0; i <= dataGridView1.RowCount - 2; i++)   //Швыряем данные в массив
            {
                for (j = 0; j <= dataGridView1.ColumnCount - 1; j++)
                {
                    ArrSave[a] = Convert.ToByte(dataGridView1[j, i].Value.ToString());
                    a++;
                }
            }
            ArrSave[a] = 255;       //Байт заглушка
            //Сохраняем табличку     
            using (FileStream output = File.Create("Actions.dat"))
            using (BinaryWriter writer = new BinaryWriter(output))
            {
                writer.Write(ArrSave);
            }
            MessageBox.Show("Save ОК");
        }

        private void button6_Click(object sender, EventArgs e)
        {
            int i = dataGridView1.CurrentRow.Index;
            int GR, UP, FO, RO;
            int GRn, UPn, FOn, ROn;
            int GRd, UPd, FOd, ROd;
            GRd = 0;
            UPd = 0;
            FOd = 0;
            ROd = 0;
            String UgolServo;

            while (i <= dataGridView1.RowCount - 3) {

            GR = Convert.ToInt32(dataGridView1[0, i].Value.ToString());
            UP = Convert.ToInt32(dataGridView1[1, i].Value.ToString());
            FO = Convert.ToInt32(dataGridView1[2, i].Value.ToString());
            RO = Convert.ToInt32(dataGridView1[3, i].Value.ToString());
            
            
            //Переход на следующую строку
            dataGridView1.Rows[i].Selected = true;
            i = i + 1;
            dataGridView1.CurrentCell = dataGridView1[0, i];

            GRn = Convert.ToInt32(dataGridView1[0, i].Value.ToString());
            UPn = Convert.ToInt32(dataGridView1[1, i].Value.ToString());
            FOn = Convert.ToInt32(dataGridView1[2, i].Value.ToString());
            ROn = Convert.ToInt32(dataGridView1[3, i].Value.ToString());


            //анализ куда гнать грейфер
            if (GRn == GR) GRd = 0;
            if (GRn < GR) GRd = -1;
            if (GRn > GR) GRd = +1;

            //анализ куда гнать вверх вниз
            if (UPn == UP) UPd = 0;
            if (UPn < UP) UPd = -1;
            if (UPn > UP) UPd = +1;

            //анализ куда гнать вынос
            if (FOn == FO) FOd = 0;
            if (FOn < FO) FOd = -1;
            if (FOn > FO) FOd = +1;

            //анализ куда гнать поворот
            if (ROn == RO) ROd = 0;
            if (ROn < RO) ROd = -1;
            if (ROn > RO) ROd = +1;

            //погнали манипулятор

            while ((GR != GRn) || (UP != UPn) || (FO != FOn) || (RO != ROn))
            {
                //грейфер
                GR = GR + GRd;           
                UgolServo = "#A";
                UgolServo = UgolServo + Convert.ToString(GR, 16);
                UgolServo = UgolServo + "|";
                port.Write(UgolServo);
                tb0.Text = Convert.ToString(GR);
                trackBar1.Value = GR;
                tb0.Refresh();
                if (GR == GRn) GRd = 0;

                //верх/низ
                UP = UP + UPd;
                UgolServo = "#B";
                UgolServo = UgolServo + Convert.ToString(UP, 16);
                UgolServo = UgolServo + "|";
                port.Write(UgolServo);
                tb4.Text = Convert.ToString(UP);
                trackBar2.Value = UP;
                tb4.Refresh();
                if (UP == UPn) UPd = 0;
                
                //вынос
                FO = FO + FOd;
                UgolServo = "#C";
                UgolServo = UgolServo + Convert.ToString(FO, 16);
                UgolServo = UgolServo + "|";
                port.Write(UgolServo);
                tb8.Text = Convert.ToString(FO);
                trackBar3.Value = FO;
                tb8.Refresh();
                if (FO == FOn) FOd = 0;             

                //поворот
                RO = RO + ROd;
                UgolServo = "#D";
                UgolServo = UgolServo + Convert.ToString(RO, 16);
                UgolServo = UgolServo + "|";
                port.Write(UgolServo);
                tb12.Text = Convert.ToString(RO);
                trackBar4.Value = RO;
                tb12.Refresh();
                if (RO == ROn) ROd = 0;
                dataGridView1.Refresh();                          
                Thread.Sleep(100);
            }

            }

        }

        private void button7_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Windows control robot arm V1", "Windows control robot arm");
            //Console.Beep(247, 200);
            //Thread.Sleep(250);

            /*
            int index = dataGridView1.CurrentRow.Index;
            while (index <= dataGridView1.RowCount-3)
            {
                dataGridView1.Rows[index].Selected = true;
                index = index + 1;
                dataGridView1.CurrentCell = dataGridView1[0, index];
                MessageBox.Show(Convert.ToString(dataGridView1.RowCount));
            }

            */

                                     
            
            }
        

    }
}
